import { AsyncIteratorResourceLike } from "@reactive-js/ix";
import { ErrorLike, ObservableLike, ObserverLike } from "@reactive-js/rx";
import { ObservableOperator } from "@reactive-js/observable";
import { SchedulerLike } from "@reactive-js/scheduler";
export interface AsyncIteratorResourceOperator<TSrcReq, TSrc, TReq, T> {
    (iter: AsyncIteratorResourceLike<TSrcReq, TSrc>): AsyncIteratorResourceLike<TReq, T>;
}
export declare const lift: <TReq, T, TA>(operator: ObservableOperator<T, TA>) => AsyncIteratorResourceOperator<TReq, T, TReq, TA>;
export declare const liftReq: <TReq, T, TReqA>(mapper: (req: TReqA) => TReq) => AsyncIteratorResourceOperator<TReq, T, TReqA, T>;
export declare function pipe<TSrcReq, TSrc, TReqA, TA>(src: AsyncIteratorResourceLike<TSrcReq, TSrc>, op1: AsyncIteratorResourceOperator<TSrcReq, TSrc, TReqA, TA>): AsyncIteratorResourceLike<TReqA, TA>;
export declare function pipe<TSrcReq, TSrc, TReqA, TA, TReqB, TB>(src: AsyncIteratorResourceLike<TSrcReq, TSrc>, op1: AsyncIteratorResourceOperator<TSrcReq, TSrc, TReqA, TA>, op2: AsyncIteratorResourceOperator<TReqA, TA, TReqB, TB>): AsyncIteratorResourceLike<TReqB, TB>;
export declare function pipe<TSrcReq, TSrc, TReqA, TA, TReqB, TB, TReqC, TC>(src: AsyncIteratorResourceLike<TSrcReq, TSrc>, op1: AsyncIteratorResourceOperator<TSrcReq, TSrc, TReqA, TA>, op2: AsyncIteratorResourceOperator<TReqA, TA, TReqB, TB>, op3: AsyncIteratorResourceOperator<TReqB, TB, TReqC, TC>): AsyncIteratorResourceLike<TReqC, TC>;
export declare function pipe<TSrcReq, TSrc, TReqA, TA, TReqB, TB, TReqC, TC, TReqD, TD>(src: AsyncIteratorResourceLike<TSrcReq, TSrc>, op1: AsyncIteratorResourceOperator<TSrcReq, TSrc, TReqA, TA>, op2: AsyncIteratorResourceOperator<TReqA, TA, TReqB, TB>, op3: AsyncIteratorResourceOperator<TReqB, TB, TReqC, TC>, op4: AsyncIteratorResourceOperator<TReqC, TC, TReqD, TD>): AsyncIteratorResourceLike<TReqD, TD>;
export declare function pipe<TSrcReq, TSrc, TReqA, TA, TReqB, TB, TReqC, TC, TReqD, TD, TReqE, TE>(src: AsyncIteratorResourceLike<TSrcReq, TSrc>, op1: AsyncIteratorResourceOperator<TSrcReq, TSrc, TReqA, TA>, op2: AsyncIteratorResourceOperator<TReqA, TA, TReqB, TB>, op3: AsyncIteratorResourceOperator<TReqB, TB, TReqC, TC>, op4: AsyncIteratorResourceOperator<TReqC, TC, TReqD, TD>, op5: AsyncIteratorResourceOperator<TReqD, TD, TReqE, TE>): AsyncIteratorResourceLike<TReqE, TE>;
export declare function pipe<TSrcReq, TSrc, TReqA, TA, TReqB, TB, TReqC, TC, TReqD, TD, TReqE, TE, TReqF, TF>(src: AsyncIteratorResourceLike<TSrcReq, TSrc>, op1: AsyncIteratorResourceOperator<TSrcReq, TSrc, TReqA, TA>, op2: AsyncIteratorResourceOperator<TReqA, TA, TReqB, TB>, op3: AsyncIteratorResourceOperator<TReqB, TB, TReqC, TC>, op4: AsyncIteratorResourceOperator<TReqC, TC, TReqD, TD>, op5: AsyncIteratorResourceOperator<TReqD, TD, TReqE, TE>, op6: AsyncIteratorResourceOperator<TReqE, TE, TReqF, TF>): AsyncIteratorResourceLike<TReqF, TF>;
export declare function pipe<TSrcReq, TSrc, TReqA, TA, TReqB, TB, TReqC, TC, TReqD, TD, TReqE, TE, TReqF, TF, TReqG, TG>(src: AsyncIteratorResourceLike<TSrcReq, TSrc>, op1: AsyncIteratorResourceOperator<TSrcReq, TSrc, TReqA, TA>, op2: AsyncIteratorResourceOperator<TReqA, TA, TReqB, TB>, op3: AsyncIteratorResourceOperator<TReqB, TB, TReqC, TC>, op4: AsyncIteratorResourceOperator<TReqC, TC, TReqD, TD>, op5: AsyncIteratorResourceOperator<TReqD, TD, TReqE, TE>, op6: AsyncIteratorResourceOperator<TReqE, TE, TReqF, TF>, op7: AsyncIteratorResourceOperator<TReqF, TF, TReqG, TG>): AsyncIteratorResourceLike<TReqG, TG>;
export declare function pipe<TSrcReq, TSrc, TReqA, TA, TReqB, TB, TReqC, TC, TReqD, TD, TReqE, TE, TReqF, TF, TReqG, TG, TReqH, TH>(src: AsyncIteratorResourceLike<TSrcReq, TSrc>, op1: AsyncIteratorResourceOperator<TSrcReq, TSrc, TReqA, TA>, op2: AsyncIteratorResourceOperator<TReqA, TA, TReqB, TB>, op3: AsyncIteratorResourceOperator<TReqB, TB, TReqC, TC>, op4: AsyncIteratorResourceOperator<TReqC, TC, TReqD, TD>, op5: AsyncIteratorResourceOperator<TReqD, TD, TReqE, TE>, op6: AsyncIteratorResourceOperator<TReqE, TE, TReqF, TF>, op7: AsyncIteratorResourceOperator<TReqF, TF, TReqG, TG>, op8: AsyncIteratorResourceOperator<TReqG, TG, TReqH, TH>): AsyncIteratorResourceLike<TReqH, TH>;
export declare function pipe<TSrcReq, TSrc, TReqA, TA, TReqB, TB, TReqC, TC, TReqD, TD, TReqE, TE, TReqF, TF, TReqG, TG, TReqH, TH, TReqI, TI>(src: AsyncIteratorResourceLike<TSrcReq, TSrc>, op1: AsyncIteratorResourceOperator<TSrcReq, TSrc, TReqA, TA>, op2: AsyncIteratorResourceOperator<TReqA, TA, TReqB, TB>, op3: AsyncIteratorResourceOperator<TReqB, TB, TReqC, TC>, op4: AsyncIteratorResourceOperator<TReqC, TC, TReqD, TD>, op5: AsyncIteratorResourceOperator<TReqD, TD, TReqE, TE>, op6: AsyncIteratorResourceOperator<TReqE, TE, TReqF, TF>, op7: AsyncIteratorResourceOperator<TReqF, TF, TReqG, TG>, op8: AsyncIteratorResourceOperator<TReqG, TG, TReqH, TH>, op9: AsyncIteratorResourceOperator<TReqH, TH, TReqI, TI>): AsyncIteratorResourceLike<TReqI, TI>;
export declare const createEvent: <T>() => AsyncIteratorResourceLike<T, T>;
export interface StateUpdater<T> {
    (oldState: T): T;
}
export declare const createStateStore: <T>(initialState: T, scheduler: SchedulerLike, equals?: ((a: T, b: T) => boolean) | undefined) => AsyncIteratorResourceLike<StateUpdater<T>, T>;
export declare const concatAll: <TReq, T>(maxBufferSize?: number) => AsyncIteratorResourceOperator<TReq, ObservableLike<T>, TReq, T>;
export declare const distinctUntilChanged: <TReq, T>(equals?: ((a: T, b: T) => boolean) | undefined) => AsyncIteratorResourceOperator<TReq, T, TReq, T>;
export declare const endWith: <TReq, T>(value: T, ...values: T[]) => AsyncIteratorResourceOperator<TReq, T, TReq, T>;
export declare const exhaust: <TReq, T>() => AsyncIteratorResourceOperator<TReq, ObservableLike<T>, TReq, T>;
export declare const ignoreElements: <TReq, TA, TB>() => AsyncIteratorResourceOperator<TReq, TA, TReq, TB>;
export declare const keep: <TReq, T>(predicate: (data: T) => boolean) => AsyncIteratorResourceOperator<TReq, T, TReq, T>;
export declare const map: <TReq, TA, TB>(mapper: (data: TA) => TB) => AsyncIteratorResourceOperator<TReq, TA, TReq, TB>;
export declare const mergeAll: <TReq, T>(options?: {
    maxBufferSize?: number | undefined;
    maxConcurrency?: number | undefined;
} | undefined) => AsyncIteratorResourceOperator<TReq, ObservableLike<T>, TReq, T>;
export declare const observe: <TReq, T>(observer: ObserverLike<T>) => AsyncIteratorResourceOperator<TReq, T, TReq, T>;
export declare const onComplete: <TReq, T>(onComplete: (err?: ErrorLike | undefined) => void) => AsyncIteratorResourceOperator<TReq, T, TReq, T>;
export declare const onError: <TReq, T>(onError: (err: unknown) => void) => AsyncIteratorResourceOperator<TReq, T, TReq, T>;
export declare const onNext: <TReq, T>(onNext: (next: T) => void) => AsyncIteratorResourceOperator<TReq, T, TReq, T>;
export declare const repeat: <TReq, T>(predicate?: number | ((count: number) => boolean) | undefined) => AsyncIteratorResourceOperator<TReq, T, TReq, T>;
export declare const retry: <TReq, T>(predicate?: ((count: number, error: unknown) => boolean) | undefined) => AsyncIteratorResourceOperator<TReq, T, TReq, T>;
export declare const scan: <TReq, T, TAcc>(scanner: (acc: TAcc, next: T) => TAcc, initialValue: TAcc) => AsyncIteratorResourceOperator<TReq, T, TReq, TAcc>;
export declare const share: <TReq, T>(scheduler: SchedulerLike, replayCount?: number | undefined) => AsyncIteratorResourceOperator<TReq, T, TReq, T>;
export declare const startWith: <TReq, T>(value: T, ...values: T[]) => AsyncIteratorResourceOperator<TReq, T, TReq, T>;
export declare const subscribeOn: <TReq, T>(scheduler: SchedulerLike) => AsyncIteratorResourceOperator<TReq, T, TReq, T>;
export declare const switchAll: <TReq, T>() => AsyncIteratorResourceOperator<TReq, ObservableLike<T>, TReq, T>;
export declare const take: <TReq, T>(count: number) => AsyncIteratorResourceOperator<TReq, T, TReq, T>;
export declare const takeLast: <TReq, T>(count: number) => AsyncIteratorResourceOperator<TReq, T, TReq, T>;
export declare const takeWhile: <TReq, T>(predicate: (next: T) => boolean) => AsyncIteratorResourceOperator<TReq, T, TReq, T>;
export declare const throttle: <TReq, T>(durationSelector: (next: T) => ObservableLike<unknown>) => AsyncIteratorResourceOperator<TReq, T, TReq, T>;
export declare const throttleTime: <TReq, T>(duration: number) => AsyncIteratorResourceOperator<TReq, T, TReq, T>;
export declare const throttleFirst: <TReq, T>(durationSelector: (next: T) => ObservableLike<unknown>) => AsyncIteratorResourceOperator<TReq, T, TReq, T>;
export declare const throttleFirstTime: <TReq, T>(duration: number) => AsyncIteratorResourceOperator<TReq, T, TReq, T>;
export declare const throttleLast: <TReq, T>(durationSelector: (next: T) => ObservableLike<unknown>) => AsyncIteratorResourceOperator<TReq, T, TReq, T>;
export declare const throttleLastTime: <TReq, T>(duration: number) => AsyncIteratorResourceOperator<TReq, T, TReq, T>;
export declare const timeout: <TReq, T>(duration: number) => AsyncIteratorResourceOperator<TReq, T, TReq, T>;
export declare const withLatestFrom: <TReq, TA, TB, TC>(other: ObservableLike<TB>, selector: (a: TA, b: TB) => TC) => AsyncIteratorResourceOperator<TReq, TA, TReq, TC>;
//# sourceMappingURL=index.d.ts.map